REM Interlaced Mask Creator for PhotoPaint 10

Direction% = 1
StartBand% = 0
BandSize% = 2
NonBandSize% = 2

REM Mask Dialog
BEGIN DIALOG OBJECT Mask 143, 99, "Mask Interlacer", SUB SubMask
	TEXT  8, 19, 52, 8, .Text1, "Mask band size:"
	SPINCONTROL  90, 15, 40, 14, .MaskSize
	OPTIONGROUP .Direction%
		OPTIONBUTTON  8, 50, 50, 10, .OptionButton1, "Vertical"
		OPTIONBUTTON  8, 62, 50, 10, .OptionButton2, "Horizontal"
	CANCELBUTTON  100, 81, 40, 14, .Cancel1
	OKBUTTON  56, 81, 40, 14, .OK1
	GROUPBOX  2, 5, 138, 72, .GroupBox1, "Mask Options"
	OPTIONGROUP .StartBand%
		OPTIONBUTTON  90, 50, 35, 10, .OptionButton3, "Even"
		OPTIONBUTTON  90, 62, 35, 10, .OptionButton4, "Odd"
	TEXT  8, 34, 70, 8, .Text2, "Non-Mask band size:"
	SPINCONTROL  90, 30, 40, 14, .NonMaskSize
END DIALOG

label1 = "This script produces an interlaced mask."
BEGIN DIALOG Dialog1 196, 74, "Interlaced Mask Creation"
	GROUPBOX  2, 1, 191, 53
	TEXT  8, 12, 178, 37, label1
	OKBUTTON  109, 57, 40, 14
	CANCELBUTTON  153, 57, 40, 14
END DIALOG

ret = DIALOG(Dialog1)
' If Cancel is selected, stop the script
IF ret = 2 THEN STOP

REM Mask Dialog SubRoutine
SUB SubMask (BYVAL ControlID%, BYVAL Event%)
	REM Initialize the values
	IF Event=0 THEN
		Mask.MaskSize.SETMINRANGE 1
		Mask.MaskSize.SETMAXRANGE 200
		Mask.MaskSize.SETVALUE 2
		
		Mask.NonMaskSize.SETMINRANGE 1
		Mask.NonMaskSize.SETMAXRANGE 200
		Mask.NonMaskSize.SETVALUE 2
	
		Mask.Direction.SETVALUE 1
		Mask.StartBand.SETVALUE 0
	End if 

End Sub	


REM Do the script
WITHOBJECT "CorelPhotoPaint.Automation.10"

	REM **** Use Document's Width and Height
	Width% = .GetDocumentWidth()
	Height% = .GetDocumentHeight()
	
	nRet = Dialog(Mask)
	if nRet = 2 then stop
	
	StartBand	= Mask.StartBand.GetValue()
	MaskSize = Mask.MaskSize.GetValue()
	NonMaskSize = Mask.NonMaskSize.GetValue()
	Direction = Mask.Direction.GetValue()
			
	Start% = StartBand

	if Start then Start = NonBandSize
	if Direction then
		WHILE Start < Height
			.MaskRectangle 0, (Start) , Width, (Start + BandSize)-1, 1, 0 		
			Start = Start + BandSize + NonBandSize
		WEND
	else
		WHILE Start < Width
			.MaskRectangle Start, 0 , Start + BandSize - 1, Height, 1, 0 		
			Start = Start + BandSize + NonBandSize
		WEND
	endif 
END WITHOBJECT


